//*****************************************************************************
/*
1.96 - Vf na zelene LED
1.78 - Vf na cervene LED

cas 10:30 zacatek >>> 18:30 vyp

s 470Ohm >>> 6mA/LED

Indikacni hladiny

3,2
3,0
2,8
2,6
2,4

Napeti na vstupech:

  MIN - MAX

1: 2.4-4.3V
2: 4.8-8.6V
3: 7.2-12.9V
4: 9.6-17.2V
5: 12-21.5V

Uvazuji min napeti clanku 2.4V, max 4.3V.

Musim je podelit na 2.2V - interni reference...

Cislo Napeti (clanek - 1) x  ADC kanal
0 x 2
1 x 1
2 x 7
3 x 6
4 x 4

unsigned char __attribute__ ((progmem))  RealnyKanal[6] = {2, 1, 7, 6, 5};

Delice - R1 seriovy, R2 nagnd
#1: R1:  10k   R2: 10k		Uout = Uin/2 >> 5mV
#2: R1:  33k   R2: 10k	/4.3 >> 10.75mV
#3: R1:  56k   R2: 10k  /6.6 >> 16.5mV
#4: R1:  68k   R2: 10k  / 7.8 >> 19.5mV
#5: R1:  100k   R2: 10k /11 >> 27.5mV

PC1 = 1, pak na PC2 merim cca 0.88V - pro detekci rezimu

Nicd monitor:
- 4.3 az 5.4V pro 4cl = 1.075V az 1.35 >>> 0.22V/ led
- 5.37 az 6.75 pro 5cl = 0.25V/led
- 6.45 az 8.1 pro 6cl = 0.33V/led

0x00-0x0F - EEPROM obsazena
0x10-0x1FF

Wishlist/buglist
- pridat bliknuti a pipnuti pri zacatku zaznamu
- dodat prerusovane piskani
- po ukoncenin nastaveni hladiny blika 5. clanek ikdyz neni pripojen!


*/
//*****************************************************************************

//----- Include Files ---------------------------------------------------------
#include <avr/io.h>		// include I/O definitions (port names, pin names, etc)
#include <avr/signal.h>	// include "signal" names (interrupt names)
#include <avr/interrupt.h>	// include interrupt support
#include <avr/pgmspace.h>
#include <stdlib.h>

#include "global.h"		// include our global settings
#include "timer.h"		// include timer function library (timing, PWM, etc)
#include "Liza.h"

#define Fw 6

//----- Begin Code ------------------------------------------------------------




void OutCompTim2 (void)		//output compare, hlavni casovani
{
	//cli();
	Count++;
	Count2++;
	TCNT2 = 0;		//jedem od zacatku
	OCR2 = 0xC8;				//200ms cca

	if ((Count == 5) & (Mod == LIZA))
	{
//		MerVeliciny();		//merime v hlavni smycce
		VypocetU();
		Vyhodnoceni();
		Count = 0;
	}
	
	
	
	if ((Sviti == 1) & (Blikani == ENABLED)) 
	{
		ZhasniLED();
		Sviti = 0;
	}
	else 
	{
		RozsvitLED();
		Sviti = 1;
	}
	//sei();
}

void OutCompTIm1 (void)
{

	TCNT1 = 0;
	OCR1A = 0x9C;		//10ms preruseni
	Tick2++;
}

INTERRUPT (SIG_INTERRUPT0)		//preruseni - tl`acitko
{

	if (PlatneTlacitko == 0)		//pockej aj se obslouzi
	{
	
		if ((MCUCR | 0xFE) == 0xFF) //prisla vzestupna - pustene tlacitko
		{
			cbi(MCUCR, 0);	//nastav zase sestupnou
			cbi(TIMSK, OCIE1A);		//zakaze int od tim1 OC
//			DlouhyObslouzen = 0;
			if (Tick2 > 9) PlatneTlacitko = 1;
			//Tick2 = 0;			
		}
		else		//zmacknute Tl
		{
			TCNT1 = 0;
			sbi(TIMSK, OCIE1A);		//povoli int od tim1 OC
			sbi(MCUCR, 0);	//vzestupna
			Tick2 = 0;			//prisla sestupna zacni merit
		}
	}

	//nez se pusti tlacitko
	//delay_ms(100);
	
}

void HoreDole(unsigned char Fn)
{
	for (xdx = 0; xdx < 6; xdx++)
	{
		SmazniLed(ZHASNI);		//vynuluje
		Led[xdx] = 1;
		RozsvitLED();
		delay_ms(Fn);
	}
	for (xdx = 4; xdx != 254; xdx--)
	{
		SmazniLed(ZHASNI);		//vynuluje
		Led[xdx] = 1;
		RozsvitLED();
		delay_ms(Fn);
	}
	
}

void uartSendByte (unsigned char DataUart)
{
	// wait for the transmitter to be ready
	//while((UCSRA | 0xDF) != 0xFF);	// ceka na odeslani 
	while((UCSRA | 0xDF) != 0xFF);	// ceka na odeslani 
	UDR = DataUart;			//posle
//	Crc = (Crc ^ DataUart);		//posila CRC
}

// function pointer to single character output routine
//static void (*rputchar)(unsigned char c);


void UartSendInt(unsigned int IPrenos)			//posle INT = 2x char
{
	uartSendByte((IPrenos>>8));	//vyssi byte
	uartSendByte(IPrenos);			//nizsi byte
}

unsigned short a2dConvert10bit(unsigned char ch)		//10bit prevod, prevzato z AVRLIB
{
	
	outb(ADMUX, (inb(ADMUX) & ~ADC_MUX_MASK) | (ch & ADC_MUX_MASK));	// set channel
	sbi(ADCSR, ADIF);						// clear hardware "conversion complete" flag 
	sbi(ADCSR, ADSC);						// start conversion
	while( bit_is_set(ADCSR, ADSC) );		// wait until conversion complete
	
	// CAUTION: MUST READ ADCL BEFORE ADCH!!!
	return (inb(ADCL) | (inb(ADCH)<<8));	// read ADC (full 10 bits);
}




void MerVeliciny (void)			//zmeri U a I
{
	
unsigned char yy, kan, kanal, zahod;

	ZhasniLED();
	cli();
	
	for (kan = 0; kan < 5; kan++)
	{
		kanal = RealnyKanal[kan];		//prekodovani na realny kanal
		zahod = a2dConvert10bit(kanal);	//dummy mereni
		Napeti[kan] = 0;
		for (yy = 0; yy < 32; yy++)
		{
			Napeti[kan] = Napeti[kan] +a2dConvert10bit(kanal);		
		}
		Napeti[kan] = (Napeti[kan]/32);
		
		//XDX_print((Napeti[kan]),5,0);
	}
	RozsvitLED();
	sei();
}

void Kalibrace (void)
{
//tady se musi nakalibrovat vsechna napeti na 3V === 3-6-9-12-15

	SmazniLed(ZHASNI);		//zhasne
	delay_ms(2000);		//pocka

	MerVeliciny();		//vsechno to zmeri

	Konst[0] = 300000/Napeti[0];
	Konst[1] = 600000/Napeti[1];
	Konst[2] = 900000/Napeti[2];
	Konst[3] = 1200000/Napeti[3];
	Konst[4] = 1500000/Napeti[4];

	EepromIntPis(0x02, Konst[0]);		//vsechny je pekne ulozi
	EepromIntPis(0x04, Konst[1]);
	EepromIntPis(0x06, Konst[2]);
	EepromIntPis(0x08, Konst[3]);
	EepromIntPis(0x0A, Konst[4]);

	SmazniLed(ROZNI);		//rozne
	while(1);

}

void VypocetU(void)
{
unsigned char prom,prom2, prom3;
unsigned long prumer;

	for (prom = 0; prom < 5; prom++)		//probehnem cely buffer
	{
		prumer = 0;
		for (prom2 = 0; prom2 < 32; prom2++)
		{
			prumer = prumer + buf[prom][prom2];
		}
		Napeti[prom] = prumer/32;
	}
	//6612B
/*
	NapetiClanek[0] = (long)(Napeti[0])*Konst[0];	// ADC hodnota krat 25 (2.5mV) krat delic
	NapetiClanek[1] = ((long)(Napeti[1])*Konst[1]) - NapetiClanek[0];	//delic 4.3
	NapetiClanek[2] = ((long)(Napeti[2])*Konst[2]) - NapetiClanek[1] - NapetiClanek[0];
	NapetiClanek[3] = ((long)(Napeti[3])*Konst[3]) - NapetiClanek[0] - NapetiClanek[1] - NapetiClanek[2];
	NapetiClanek[4] = ((long)(Napeti[4])*Konst[4]) - NapetiClanek[0] - NapetiClanek[1] - NapetiClanek[2] - NapetiClanek[3];
*/

	NapetiClanek[0] = (long)(Napeti[0])*Konst[0];	// ADC hodnota krat 25 (2.5mV) krat delic
	NapetiClanek[1] = ((long)(Napeti[1])*Konst[1] - NapetiClanek[0]);
	NapetiClanek[2] = ((long)(Napeti[2])*Konst[2] - ((long)(Napeti[1])*Konst[1]));
	NapetiClanek[3] = ((long)(Napeti[3])*Konst[3] - ((long)(Napeti[2])*Konst[2]));
	NapetiClanek[4] = ((long)(Napeti[4])*Konst[4] - ((long)(Napeti[3])*Konst[3]));

	
	for (prom3 = PlatnychClanku; prom3 < 5; prom3++)
	{
		NapetiClanek[prom3] = 0;		//nepripojene clanky = 0V
	}
	
}


//******************************************************************************


void XDX_print (long CoTisknout, unsigned char Pred, unsigned char Po)
{
unsigned char i,j, minus, Tecka = 0;
long int CoTisknoutInt = 0;
unsigned char buf[9] = {"        "};


	i = 0;
	if (CoTisknout < 0)				//ok, udela se jen korekce znamenka
	{
		minus = 1;
		CoTisknout = CoTisknout * -1;
	}
	else minus = 0;
	
	CoTisknoutInt = (CoTisknout);
	for (j = 0; j < (Pred + Po); j++)
	{
		buf[i] = ((CoTisknoutInt % 10) + 48);
		//buf[i] = i + 48;
		i++;
		CoTisknoutInt	= CoTisknoutInt / 10;
		if (j == (Po-1))
		{
			buf[i] = '.';				//XXXXXXX
			//buf[i] = ',';
			Tecka = i;			//pozice tecky
			i++;
		}
	}

   	
	j = (Pred + Po);
	while ((buf[j] <= 48) & (j != 0))
	{
		if ((buf[j] == 48)& (buf[j-1] != '.')) buf[j] = 32;	//prepise nuly na mezery
		//if ((buf[j] == 48)& (buf[j-1] != ',')) buf[j] = 32;	//prepise nuly na mezery
		j--;
		if (j == Tecka) break;
	}
	
	j = (Pred + Po);
	if (minus)
   	{
   		while (j != 0)
		{
			if (buf[j-1] > 47)
			{
				buf[j] = '-';
				break;
			}
			j--;
		}
   		
   	}
	
		
	i = (Pred + Po);
	if (Po != 0) i++;	//des tecka
//	if (minus == 1) i++;
	
	for (j = i-1; j < 100; j--)
	{
		uartSendByte(buf[j]);
   	}


}

void HledejPlatneClanky (void)			//spocita pocet clanku
{
	PlatnychClanku = 0;
	MerVeliciny();
	for (p = 0; p <5; p++)
	{
		if (Napeti[p] > 100) PlatnychClanku++;
	}


}

void Vyhodnoceni(void)		//uvodni hledani nejnizsi hladiny
{
unsigned char r,s;
unsigned char PuvodniHladina;

	PuvodniHladina = Hladina;
	
	for (r = 0; r < 6; r++)	//projedem vsechna napeti 
	{
		for (s = 0; s < PlatnychClanku; s++)	//tady jezdim s napetimi
		{
			if (NapetiClanek[s] < UrovenHladiny[r]) 
			{
				Hladina = r;		//hledam nejmensi napeti a priradim hladinu
			}
			if (NapetiClanek[s] < MinNapetiClanek[s]) MinNapetiClanek[s] = NapetiClanek[s]; //nejmensi nap na clanek
		}
		
	}
	if (PuvodniHladina < Hladina)
	{
		Zmena = 1;		
		if ((Hladina >= HladinaAlarm)) sbi(PORTD, PISKAC);		//piskat!!!!
	}
	else Hladina = PuvodniHladina;		//musis vratit tu nizsi

	

	
//ted znam nejnizsi hladinu - pozor to funguje online, pokud napeti vyleze, prestane to indikovat.

	if (Zmena == 1)
	{
		for (p = 0; p < PlatnychClanku; p++)		//smazne ty stary
		{
			KteryClanek[p] = 0;
		}
		Zmena = 0;
	}
	for (r = 0; r < PlatnychClanku; r++)
	{
		if (NapetiClanek[r] < UrovenHladiny[Hladina]) KteryClanek[r] = 1; //je v teto hladine
		//else KteryClanek[r] = 0;		//neni v te hladine
	}
	
	
}

void ZhasniLED(void)
{
	cbi (PORTD, LED1);
	cbi (PORTD, LED2);
	cbi (PORTD, LED3);
	cbi (PORTD, LED4);
	cbi (PORTD, LED5);
}



void SmazniLed(unsigned char Jak)			//nebo rozsvit, podle toho
{
	for (p = 0; p < 5; p++)
	{
		Led[p] = Jak;		//vse zhasne nebo rozne
	}
}

void RozsvitLED (void)		//rozsviti ledky podle Led pole
{
	if (Led[0] == 1) sbi(PORTD,LED1);
	else cbi(PORTD,LED1);
	if (Led[1] == 1) sbi(PORTD,LED2);
	else cbi(PORTD,LED2);
	if (Led[2] == 1) sbi(PORTD,LED3);
	else cbi(PORTD,LED3);
	if (Led[3] == 1) sbi(PORTD,LED4);
	else cbi(PORTD,LED4);
	if (Led[4] == 1) sbi(PORTD,LED5);
	else cbi(PORTD,LED5);
}

void NastavAlarm (void)			//nastavi alarm pro piskani
{
unsigned char Ulozit = 0;

	HoreDole(50);
	HoreDole(50);
	HoreDole(50);
	SmazniLed(ROZNI);		//smaze a da nove nastaveni
	
	VyctiData();
	if (HladinaAlarm > 6) HladinaAlarm = 1;

	SmazniLed(ZHASNI);		//smaze a da nove nastaveni
	Led[HladinaAlarm-1] = 1;

	PlatneTlacitko = 0;		//obslouzeno
	Tick2 = 0;

	while (Ulozit == 0)
	{
		if ((Tick2 > 200))		//dlouhy stisk - reaguje hned
		{
			SmazniLed(ZHASNI);
			PlatneTlacitko = 0;		//obslouzeno
			Tick2 = 0;
			Ulozit = 1;		//ulozit do pameti
			PlatneTlacitko = 0;		//obslouzeno
		}
		else if ((PlatneTlacitko == 1) & (Tick2 > 9))	//kratky stisk
		{
			HladinaAlarm++;
			if (HladinaAlarm == 6) HladinaAlarm = 1;
			SmazniLed(ZHASNI);		//smaze a da nove nastaveni
			Led[HladinaAlarm-1] = 1;
			PlatneTlacitko = 0;		//obslouzeno
		}
	}
	
	Eeprom(00, HladinaAlarm, PIS);		//zapise
	HoreDole(50);
	HoreDole(50);
	HoreDole(50);
	HoreDole(50);

}

void NastavLED(void)
{
	if (Rezim == NAP)	//mame zobrazit hladiny
	{
		for (p = 0; p < 5; p++)
		{
			Led[p] = KteryClanek[p];
		}
		Blikani = DISABLED;
	}
	
	if (Rezim == HLAD)
	{
		SmazniLed(ZHASNI);
		
		if (Hladina != 0)			//1 >>5, 2 >> 4
		{
			Led[Hladina-1] = 1;
		}
		Blikani = ENABLED;
	
	}

}

unsigned char Eeprom (unsigned int Adr, unsigned char EData, unsigned char Akce)
{
unsigned char Vratit=0;
//nezakazat tady preruseni?
	cli();		//zakaz pro jistotu preruseni
	if (Akce == PIS)
	{
		while(EECR & (1 << EEWE));
		EEAR = Adr;
		EEDR = EData;
		EECR |= (1 << EEMWE);
		EECR |= (1<<EEWE);
	}
	else
	{
		while(EECR & (1 << EEWE));
		EEAR = Adr;
		EECR |= (1 << EERE);
		Vratit = EEDR;
	}
	while(EECR & (1 << EEWE));		//az to dopise
	sei();
//	delay_ms(10);
	//nepridat delay 10ms - az se to zapise????
	
	return(Vratit);
}

void EepromIntPis(unsigned int KamPsat, unsigned int IntData)
{				//zapise INT do eeprom procaku

	Eeprom (KamPsat,(IntData>>8),PIS);		//pis hi byte
	Eeprom ((KamPsat+1),IntData,PIS);		//pis low


}

unsigned int EepromIntCti(unsigned int OdkudCist)
{
unsigned int Vracim;

	Vracim = Eeprom(OdkudCist, 00, CTI);		//adresa odkud
	Vracim = (Vracim <<8) + Eeprom((OdkudCist +1), 00, CTI);	
	return(Vracim);
}

void PosliDataSeriovkou(void)
{
// posle data po seriovce ven
// asi jednak aktualni napeti clanku
// a asi take nejnizsi napeti na dany clanek? - to musim jeste dodelat
//----------------	(tohle je 16 znaku displeje)
//M 4.20 4.20 4.20
// 4.20 4.20

	//cli();
	sbi(UCSRB,TXEN);		//povoli TX
	sbi (PORTD, PISKAC);
//XXXXXXXXXXXXXXX tady pridat zpozdeni?
	delay_ms(2);
	uartSendByte('#');		//uvodni znak, na to se bude chytat HIB
	
	if (Rezim == NAP)		//co ma poslat
	{
		uartSendByte('M');
		uartSendByte(' ');
		for (p = 0; p < 5; p++)
		{
			//uartSendByte(p+49);
			//uartSendByte(':');
			XDX_print((MinNapetiClanek[p]/1000),1,2);
			uartSendByte(' ');
		}
	}
	else
	{
	
		uartSendByte('A');
		uartSendByte(' ');
//		MerVeliciny();
	//	VypocetU();
		for (p = 0; p < 5; p++)
		{
			//uartSendByte(p+49);
			//uartSendByte(':');
			XDX_print((NapetiClanek[p]/1000),1,2);
			uartSendByte(' ');
		}
	}
	uartSendByte('#');		//uvodni znak, na to se bude chytat HIB
	uartSendByte(10);
	uartSendByte(13);
	cbi(UCSRB,TXEN);		//zakaze TX
	
	//cbi(TIMSK, OCIE1A);		//zakaze int od tim1 OC
	//PlatneTlacitko = 0;
	//Tick2 = 0;
	
	//sei();
	cbi (PORTD, PISKAC);
}

void PosliMinMaxSeriovkou(unsigned int Napp)
{
// posle data po seriovce ven
//----------------	(tohle je 16 znaku displeje)
//A 12.3 M 10.9


	//cli();
	sbi(UCSRB,TXEN);		//povoli TX
	sbi (PORTD, PISKAC);

//XXXXXXXXXXXXXXX tady pridat zpozdeni?
	delay_ms(2);
	uartSendByte('#');		//uvodni znak, na to se bude chytat HIB
	
	uartSendByte('A');
	uartSendByte(' ');
	MerVeliciny();
	VypocetU();
	XDX_print((Napp),2,2);
	uartSendByte(' ');
	uartSendByte('M');
	uartSendByte(' ');
	XDX_print((MinNap),2,2);

	uartSendByte('#');		//uvodni znak, na to se bude chytat HIB
	uartSendByte(10);
	uartSendByte(13);
	cbi(UCSRB,TXEN);		//zakaze TX
	
	//cbi(TIMSK, OCIE1A);		//zakaze int od tim1 OC
	//PlatneTlacitko = 0;
	//Tick2 = 0;
	
	//sei();
	cbi (PORTD, PISKAC);
}


void Bargraf (void)			//tady mozna jeste dodelat hlidani minimalnihodnoty
{
unsigned long Nap=0,xxx;
unsigned char St, HladinaBar, yyy;

	HladinaBar = HladinaAlarm - 1;

	MinNap = 3000;		//max napeti
	cbi (ADCSRA, ADPS2);
	cbi (ADCSRA, ADPS1);
	cbi (ADCSRA, ADPS0);		///000 = /2 preddelic


	SmazniLed(ZHASNI);

	while (1)			//tady to trosku vylepsit
	{
		if ((Tick2 > 200))		//dlouhy stisk - reaguje hned
		{
			HoreDole(50);
			HoreDole(50);
			MinNap = 3000;		//max napeti
			RezimB = NORM;
			Tick2 = 0;
			PlatneTlacitko = 0;
		}
		else if ((PlatneTlacitko == 1) & (Tick2 > 9))
		{
			if (RezimB == MINIM)	RezimB = NORM;
			else RezimB = MINIM;
			PosliMinMaxSeriovkou(Nap);
			PlatneTlacitko = 0;		//obslouzeno
		}


		ZhasniLED();
		
		Napeti[4] = 0;
		
		for (yyy = 0; yyy < 16; yyy++)
		{
			Napeti[4] = Napeti[4] +a2dConvert10bit(4);		
		}
		Napeti[4] = (Napeti[4]/16);
		
		if (Sviti == 1) RozsvitLED();
		NapetiClanek[4] = (((long)(Napeti[4])*Konst[4])/1000);		
		Nap = (unsigned int)(NapetiClanek[4]);		//pretypuju

		if (Nap < MinNap) MinNap = Nap;
		
		if (RezimB == NORM)
		{
		
			if (Nap <= (Nicd[HladinaBar][0]*10))	
			{
				Blikani = ENABLED;
				St = 5;		//uz nekontroluje dal
				Led[4] = 1;
			}
			else St = 0;
		
		
			for (p = St; p <5; p++)
			{
				if (Nap > (Nicd [HladinaBar][p]*10)) Led[4-p] = 1;
				else Led[4-p] = 0;	
				Blikani = DISABLED;
			}
		}
		else
		{
			for (p = 0; p <5; p++)
			{
				if (MinNap > (Nicd [HladinaBar][p]*10)) Led[4-p] = 1;
				else Led[4-p] = 0;	
				Blikani = ENABLED;
			}
			if (MinNap <= (Nicd[HladinaBar][0]*10)) Led[4] = 1;
		}
		
		
		
		
//		RozsvitLED();
		//delay_ms(150);
		
		for (xxx = 0; xxx < 100; xxx++)		//cekaci smycka
		{
			asm volatile ("nop\n nop\n nop\n nop\n nop\n");
		}
		
	}


}

void TestRezimu (void)		//otestuje zda je pripojen jumper >>> indikace clanku
{
unsigned int Hod;

	DDRC = 0x02; 		//nastavi 3. pin od gnd do log 1
	PORTC = 0x02;		// kdyz je to 0 >> Liza, kdyz je to 0.9V >> INDIK, kdyz je to > 1.2V Liza

	Hod = a2dConvert10bit(2);		//na kanalu 2 (2. pin od gnd) to precte

	if ((Hod < 50) | (Hod > 400)) Mod = LIZA;		//kolem nuly a pres 1.2V znamena Lizu
	else Mod = INDIK;				// indikator
	
		
	DDRC = 0x00; 		// da to zase zpet
	PORTC = 0x00;
	
}

void UlozData (void)
{
// 2.00 - 4.30 = 200-430 = 230
unsigned int Hodn;
	
	for (p = 0; p < 5; p++)
	{
		Hodn = ((NapetiClanek[p]/1000));
		if (Hodn != 0) Hodn = Hodn - 200;
		Eeprom(AdresaM,Hodn,PIS);
		AdresaM++;
	
	}
	
}

void VyctiData (void)		//0x01F9
{
unsigned int HHod=0, Cas=30;
unsigned char pp=0;

	sbi(UCSRB,TXEN);		//povoli TX
	
	//XXXXXXXXXXXXXXX tady pridat zpozdeni?
	delay_ms(2);
	AdresaM = 0x10;
	uartSendByte(10);
	uartSendByte(13);
	XDX_print (Cas,3,0);
	uartSendByte(';');
	while (HHod != 0x1C7)		//200+255 = FFko na konci zaznamu	XXXX
	//while (AdresaM < 0x01F9)
	{
		HHod = Eeprom(AdresaM,0x00,CTI);
		//HHod = HHod + 200;		//XXXXX
		//XDX_print (HHod, 1,2);	//XXX
		//uartSendByte(';');		//XXX
		
		if (HHod != 0) HHod = HHod + 200;
		if (HHod != 0x1C7)
		{
			XDX_print (HHod, 1,2);
			uartSendByte(';');
		}
		
		//delay_ms(10);
		AdresaM++;
		
		pp++;
		if (pp == 5)
		{
			pp = 0;
			Cas = Cas + 6;		//po cca 6ti sec
			uartSendByte(10);
			uartSendByte(13);
			XDX_print (Cas,3,0);	//at to neposila aj na konci
			uartSendByte(';');
			
			//HoreDole();
		}
	}
	uartSendByte(';');	//koncovy znak
	
	cbi(UCSRB,TXEN);		//povoli TX
}

void SmazniPamet (void)		//napis sama FFka
{
unsigned int Cou;

	for (Cou = 0x10; Cou < 510; Cou++)
	{
		Eeprom(Cou,0xFF,PIS);
	}


}

int main(void)
{

// USART 8N1 Receiver: On USART Transmitter: On Mode: Asynchronous  Baud rate: 57600

	UCSRA=0x22;		//U2X = 1
	UCSRB=0x18;
	UCSRC=0x86;
	UBRRH=0x00;
	UBRRL=12;	//12 >>> 9600

	timerInit();
	timer1SetPrescaler (TIMER_CLK_DIV64);		//sutr podelit 64 POKUS
	sbi(ADCSR, ADEN);				// enable ADC (turn on ADC power)
	cbi(ADCSR, ADFR);				// default to single sample convert mode
	outb(ADMUX, ((inb(ADMUX) & ~ADC_REFERENCE_MASK) | (ADC_REFERENCE_256V<<6)));	// set default reference
	cbi(ADMUX, ADLAR);				// set to right-adjusted result

	sbi (ADCSRA, ADPS2);
	sbi (ADCSRA, ADPS1);
	sbi (ADCSRA, ADPS0);		///111 = 128 preddelic

	DDRD = 0xFA;			//tlacitko a rxd vstupy
	PORTD = 0xFD;			// zapne pullup pro tlac a rxd, ledky roznem
	DDRC = 0x00; 		//vstupy ADC 00
	PORTC = 0x00;
	DDRB = 0x0F;		//MISO je jako vstup, MOSI jako vystup
	PORTB = 0xF0;		//nahore pullupy, dole nuly

	sei();
	
	timer2Init();			
	timer2SetPrescaler(TIMERRTC_CLK_DIV1024);
	OCR2 = 0xC8;
	timerAttach(TIMER2OUTCOMPARE_INT, OutCompTim2);
	sbi(TIMSK, OCIE2);		//povoli int od tim2 OC
	TCNT2 = 0;		//jedem od zacatku
	
	timerAttach(TIMER1OUTCOMPAREA_INT, OutCompTIm1);
	OCR1A = 0x9C;		//10ms preruseni

	sbi(GICR,6); //spusti INT0 preruseni
	sbi(MCUCR, 1);	//pouze hranou dolu	ISC01
	
	cbi(UCSRB,TXEN);		//zakaze TX
	cbi(UCSRB,RXEN);		//zakaze RX

	delay_ms(1000);
	SmazniLed(ZHASNI);
	delay_ms(300);



	n = 0;
	for (p = 2; p < 0x0B; p = p+2)
	{
		Konst[n] = EepromIntCti(p);		//nacti konstanty
		n++;
	}
	HladinaAlarm = Eeprom(00, 0, CTI);
	HledejPlatneClanky();


	MerVeliciny();		//zmeri puvodni hodnoty
	VypocetU();		//vypocita to 
		
	
	if ((PIND & 0x04) == 0) NastavAlarm();


	TestRezimu();		//zjisti, zda jeden Lizu nebo Indikator

	PlatneTlacitko = 0;		//obslouzeno
	Tick2 = 0;
	cbi(TIMSK, OCIE1A);		//zakaze int od tim1 OC
	if (Mod == INDIK) Bargraf();			//ukazuje online napeti na ledkach
	AdresaM = 0x10;
	ZaznamPovolen = 0;
	Count2 = 0;		//nulovat pocitadla	
	Hladina = 0; 		//tzn vice nez 3.2V, uvodni stav	
	
	while(1)
	{
		if (ZaznamPovolen == 0)
		{
			if (Count2 > 0x96) 
			{
				SmazniPamet();			///XXXXXXXXXXXXXXXXXXXXXXXXXXXLOJZA
				ZaznamPovolen = 1;		//spusti zaznam po 30 sec
				HoreDole(20);			//XXXX
				HoreDole(20);			//XXXX
				HoreDole(20);			//XXXX
				HoreDole(20);			//XXXX
			}
		}
		if (UdelejMinima == 0)
		{
			if (Count2 > 0x0A)		// pocca 2 sec vem hodnoty jako minimum
			{
				for (p = 0; p < PlatnychClanku; p++)
				{
					MinNapetiClanek[p] = NapetiClanek[p];	// = minimalni hodnota
				}
				UdelejMinima = 1;
			}
		}



		
		if ((Tick2 > 200) )		//dlouhy stisk - reaguje hned
		{
			HoreDole(50);
			HoreDole(50);
			Hladina = 0;
			Zmena = 1;		//prepis ledky
			for (p = 0; p < PlatnychClanku; p++)	//smazne aj minima
			{
				MinNapetiClanek[p] = NapetiClanek[p];	// = minimalni hodnota
			}
			cbi (PORTD, PISKAC); //presnate piskat
			PlatneTlacitko = 0;		//obslouzeno
			cbi(TIMSK, OCIE1A);		//zakaze int od tim1 OC
			Tick2 = 0;
		}
		else if ((PlatneTlacitko == 1) & (Tick2 > 9))
		{
			if (Rezim == NAP)	Rezim = HLAD;
			else Rezim = NAP;
			cbi (PORTD, PISKAC); //presnate piskat
			PlatneTlacitko = 0;		//obslouzeno
			NastavLED();
			PosliDataSeriovkou();	//posle data po seriovce ven
		}


		if ((Count2 >= 30) & (ZaznamPovolen == 1))
		{
			if (AdresaM < 0x01F9) UlozData();		//ukladat data	ale jen do konce pameti XXXXXXXXXXXLOJZA
			Count2 = 0;
		}
		if ((PINB | 0xEF) == 0xEF)  Kalibrace();


		for (chan = 0; chan < 5; chan++)
		{
			channel = RealnyKanal[chan];		//prekodovani na realny kanal
			buf[chan][pointer] = a2dConvert10bit(channel);
		}
		pointer++;
		if (pointer == 32) pointer = 0;	//pisem od zacatku

		
		
//		VypocetU();
	//	Vyhodnoceni();
		NastavLED();		//zapne spravne ledky
	}
	
	return(0);

}
